

object BadListCP {

  def empty ():BadListCP = new ListEmpty()

  def cons (n:CPoint, L:BadListCP):BadListCP = new ListCons(n,L)


  // EMPTY LIST REPRESENTATION
  //
  private class ListEmpty () extends BadListCP {
    def isEmpty ():Boolean = true
    def first ():CPoint = 
      throw new RuntimeException("empty().first()")
    def rest ():BadListCP = 
      throw new RuntimeException("empty().rest()")
    def length ():Int = 0
    def find (f:CPoint):Boolean = false


    def toStringLst ():String = "]"
    override def toString ():String = ""
  }


  // CONS LIST REPRESENTATION
  //
  private class ListCons (n:CPoint, L:BadListCP) extends BadListCP {
    def isEmpty ():Boolean = false
    def first ():CPoint = n
    def rest ():BadListCP = L
    def length ():Int = 1 + L.length()

    def find (f:CPoint):Boolean = { 
      println("Trying to find value " + f + " with color " + f.color())
      (f == n) || L.find(f) 
    }

    def toStringLst ():String = "," + n + L.toStringLst()
    override def toString ():String = "[" + n + L.toStringLst()
  }
}


// reinstate subtyping to try examples
//
// abstract class BadListCP extends List[CPoint] {
abstract class BadListCP {

  def isEmpty ():Boolean
  def first ():CPoint
  def rest (): BadListCP
  def length ():Int
  def find (f:CPoint):Boolean

  protected def toStringLst ():String
}
