
class Point (x:Int, y:Int)  {

  /* executed whenever you create a Point instance */

  if (x < 0 || y < 0)
    throw new IllegalArgumentException("Point not positive")

  private var xpos:Int = x
  private var ypos:Int = y

  def xCoord ():Int = xpos
  def yCoord ():Int = ypos

/*
  def setXCoord (x:Int):Unit = 
    if (x >= 0)
      xpos = x
    else 
      throw new IllegalArgumentException("Point not positive")

  def setYCoord (y:Int):Unit = 
    if (y >= 0)
      ypos = y
    else 
      throw new IllegalArgumentException("Point not positive")

  def deepCopy ():Point = 
    new Point(xCoord(),yCoord())
*/

  override def toString ():String = "(" + xpos + "," + ypos + ")"
}
