
object Test {
  
  def main (argv:Array[String]):Unit = run()

  def xCoords (l:List[Point]):List[Int] = {
    if (l.isEmpty())
      List.empty[Int]()
    else
      List.cons(l.first().xCoord(),xCoords(l.rest()))
  }
  
  def colors (l:List[CPoint]):List[String] = {
    if (l.isEmpty())
      List.empty[String]()
    else
      List.cons(l.first().color(),colors(l.rest()))
  }
  
  def run ():Unit = {
    
    val p:Point = new Point(40,50)
    val q:Point = new Point(400,500)
    val l:List[Point] = List.cons(p,List.cons(q,List.empty()))
    
    val cp:CPoint = new CPoint(10,20,"red")
    val cq:CPoint = new CPoint(100,200,"blue")
    val cl:List[CPoint] = List.cons(cp,List.cons(cq,List.empty()))

    println("l = " + l)
    println("cl = " + cl)
    println("xCoords(l) = " + xCoords(l))
    println("colors(cl) = " + colors(cl))

    // testing covariance:
    // println("xCoords(cl) = " + xCoords(cl))

    // testing update: [List must be invariant]
    // cl.update(new CPoint(1,2,"mauve"))
    // println("cl = " + cl)

    // testing find: [List must be invariant, or using find[U >: T] version
    // println("cl.find(cp) = " + cl.find(cp))
    // println("cl.find(new CPoint(44,55,\"green\")) = " + 
    //         cl.find(new CPoint(44,55,"green")))
    
  }
}

